from constants import *
from numpy import *

def calculateArrow(pos, objectList):
	fixedVector = zeros(2, "f")
	rotVector = zeros(2, "f")
	
	for object in objectList:
		fixedVector += object.getEffectOnPoint(pos, True)
		rotVector += object.getEffectOnPoint(pos, False)
				
	return Arrow(array(pos, "f"), fixedVector, rotVector)		
		
		
class Arrow:
	def __init__(self, pos, fixedVector, rotVector):
		self.pos = pos
		self.fixedVector = fixedVector
		self.rotVector = rotVector
		self.vector = fixedVector + rotVector
		self.strength = sqrt(sum(self.vector ** 2))

	def getPos(self):
		return self.pos
		
	def getFixedVec(self):
		return self.fixedVector
		
	def getRotVec(self):
		return self.rotVector		
		
	def getVec(self):
		return self.vector 
		
	def getStrength(self):
		return self.strength
		
	def setVec(self, rotVector):
		self.rotVector = rotVector
		self.vector = self.fixedVector + rotVector
		self.strength = sqrt(sum(self.vector ** 2))
		
		
		
		