import sys

import pygame
from pygame.locals import *
from OpenGL.GL import *
from  OpenGL.GLU import *

import data
from constants import *
from arrow import *
from world import *


world = None

def main():
	global world
	pygame.init()
	setupScreen()
	initOGL()
	
	world = World(0)
	
	clock = pygame.time.Clock()
	clock.tick()
	
	while 1:
		if checkEvents():
			world = world.genNextLevel()
		
		checkKeyStates()
		
		update()
		draw()
		
		pygame.display.flip()

		print 1000.0 / clock.tick(TICK_RATE)
		
def setupScreen():
	pygame.display.set_mode((800, 600), OPENGL | DOUBLEBUF)
		
def initOGL():
	glClearColor(*GROUND_COLOR)
	glClear(GL_COLOR_BUFFER_BIT)
	glEnable(GL_BLEND)
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
	glShadeModel(GL_SMOOTH)
	
	glEnable(GL_LINE_SMOOTH)
	glHint(GL_LINE_SMOOTH_HINT, GL_NICEST)
	
	glEnable(GL_POINT_SMOOTH)
	glHint(GL_POINT_SMOOTH_HINT, GL_NICEST)	
	
	glMatrixMode(GL_PROJECTION)
	glLoadIdentity()
	gluOrtho2D(0, SCREEN_RES[0], 0, SCREEN_RES[1])
		
	glMatrixMode(GL_MODELVIEW)
	glLoadIdentity()
		
def checkEvents():
	for event in pygame.event.get():
		if event.type == QUIT:
			sys.exit(0)
		#print event
		#print pygame.key.get_focused()
			
def checkKeyStates():
	pressed = pygame.key.get_pressed()
	if pressed[K_LEFT]:
		world.rotate(False)
	elif pressed[K_RIGHT]:
		world.rotate(True)
		
def update():
	world.update()
			
def draw():
	glClear(GL_COLOR_BUFFER_BIT)
	world.draw()