from math import *

from numpy import *

from constants import *
from vector import *

class Object:
	def __init__(self, strength, orientation, bFixed):
		self.strength = strength
		self.orientation = orientation
		self.bFixed = bFixed
		
class RSquaredObject(Object):
	def __init__(self, pos, strength, orinetation, bFixed):
		Object.__init__(self, strength, orinetation, bFixed)
		self.pos = array(pos, "f")

	def getEffectOnPoint(self, point, bFixed):
		if self.bFixed == bFixed:
			point = array(point, "f")
			relVec = rotateVector(self.pos - point, self.orientation)
			
			distanceSq = float(sum(relVec ** 2))
			
			if distanceSq:
				return relVec * self.strength / distanceSq
			else:
				return zeros(2, "f")		
		else:
			return array((0, 0), "f")
			
class GravityWell(RSquaredObject):
	def __init__(self, pos, strength, bFixed):
		RSquaredObject.__init__(self, pos, strength, 0, bFixed)
		
class Spinner(RSquaredObject):
	def __init__(self, pos, strength, bClockwise, bFixed):
		if bClockwise:
			angle = pi / 2
		else:
			angle = 3 * pi / 2
	
		RSquaredObject.__init__(self, pos, strength, angle, bFixed)
		
class AreaObject(Object):
	def __init__(self, strength, orientation, areaRect, bFixed):
		Object.__init__(self, strength, orientation, bFixed)
		self.areaRect = areaRect
		
	def getEffectOnPoint(self, point, bFixed):
		if self.bFixed == bFixed:
			if self.areaRect.collidepoint(point):
				return rotateVector(array((1, 0), "f"), self.orientation) * self.strength
		else:
			return array((0, 0), "f")